/* My gateway routine for Matlab <--> C crossover */

#include "mex.h"
#include "matrix.h"
#include "turbo_dvbrcs.h"

#define FRAMES plhs[0]
#define ERRORS plhs[1]
#define ERRORLEN plhs[2]
#define ITERATIONS plhs[3]
#define SIGMAS plhs[4]

typedef struct { float *errors, *Lcer; int errorsLength, frames, snrSteps;} Results;

Results *testGauss();

void mexFunction(
				 int nlhs, mxArray *plhs[], 
				 int nrhs, const mxArray *prhs[]) 
{
    double *errorsOut, *framesOut, *lenOut, *stepsOut, *sigmaOut;
	float *temp,*temp2;
	int loop,ll,lenTemp,shift,stepsTemp;
    Results *res;
    
    /* Check for proper number of arguments */
    if (nrhs != 0) { 
        mexErrMsgTxt("No input required."); 
    }
    
    else if (nlhs != 5) {
        mexErrMsgTxt("Needs five output arguments."); 
    }
	
    res = testGauss();
	
	FRAMES = mxCreateDoubleMatrix(1, 1, mxREAL);
	framesOut = mxGetPr(FRAMES);
	*framesOut = res->frames;
	
	ERRORLEN = mxCreateDoubleMatrix(1, 1, mxREAL);
	lenOut = mxGetPr(ERRORLEN);
	lenTemp = res->errorsLength;
	*lenOut = (double) lenTemp;
	
	ITERATIONS = mxCreateDoubleMatrix(1, 1, mxREAL);
	stepsOut = mxGetPr(ITERATIONS);
	stepsTemp = res->snrSteps;
	*stepsOut = (double) stepsTemp;
	
	temp = res->errors;	
	temp2 = res->Lcer;
	
    SIGMAS = mxCreateDoubleMatrix(1, stepsTemp, mxREAL);
    sigmaOut = mxGetPr(SIGMAS);
	
	for(ll=0; ll<stepsTemp; ll++) {
		*(sigmaOut + ll) = (double) ( *(temp2 + ll));
	}
	
    ERRORS = mxCreateDoubleMatrix(stepsTemp, lenTemp, mxREAL);
    errorsOut = mxGetPr(ERRORS);
	
	shift = 0;
	for(ll=0; ll<stepsTemp; ll++) {
		shift = ll*lenTemp;
		for(loop=0; loop<lenTemp; loop++){
			*(errorsOut + loop + shift) = (double) ( *(temp + loop + shift));
		}
	}
	
	free(temp);
	free(res);
}