/*  turbo_dvbrcs.h
 *
 *  Written by Christian Nordahl
 */

#ifndef TURBO_DVBRCS_H
#define TURBO_DVBRCS_H

#define K 4					/* constraint length */
#define NUMSTATES 8			/* 2^(K - 1) -- change as required */

#define PI 3.141592654		/* circumference of circle divided by diameter */

#define N 212				/* Block sizes (N/4 = bytes) */
#define R 3					/* code rate number: R=1, code rate r=1/3; R=2, code rate r=2/5;     */
/* R=3, code rate r=1/2; R=4, code rate r=2/3; R=5, code rate r=3/4; */
/* R=6, code rate r=4/5; R=7, code rate r=6/7; */

#define DECITER 8			/* the number of decoding iterations */
#define MINFRAMES 200		/* the minimum number of frames to be simulated */

#define LOEBN0 1.5			/* minimum Eb/No at which to test */
#define HIEBN0 3.001		/* maximum Eb/No at which to test */
#define EBN0STEP 0.5		/* Eb/No increment for test driver */

#endif