/*  turbo_phi.h
 *
 *  Written by Christian Nordahl
 */

#ifndef TURBO_PHI_H
#define TURBO_PHI_H

#define PI 3.141592654		/* the random noise generator needs this */

#define N 752				/* Block sizes (N/4 = bytes) must be chosen among th following list: */
							/* {48, 64, 212, 220, 228, 424, 432, 440, 752, 848, 856, 864} */
#define R 1					/* code rate number: R=1, code rate r=1/3; R=2, code rate r=2/5;     */
							/* R=3, code rate r=1/2; R=4, code rate r=2/3; R=5, code rate r=3/4; */
							/* R=6, code rate r=4/5; R=7, code rate r=6/7; */

#define DECITER 8			/* the number of decoding iterations */
#define MINFRAMES 5000		/* the minimum number of frames to be simulated */
#define MAXFRAMES 500000	/* the maximum number of frames to be simulated */
#define MINERRORS 50		/* the minimum number of bit-errors to be generated */

#define LOEBN0 1.00			/* minimum Eb/No at which to test */
#define HIEBN0 1.751		/* maximum Eb/No at which to test */
#define EBN0STEP 0.25		/* Eb/No increment for test driver */

typedef struct { int *errorPos, *frames, *onecheck, *zerocheck; double *ber, *fer; int blockLength, rate, snrIters;} Results;

#endif
