% Mainfile for my masters thesis. Includes setup parameters such as
% blocksize(in bytes), number of blocks, input sequence, SNR, etc%%%
%%%%%%%% Abandoned after decision about implementing all of the turbocode in C %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%% SETUP
clear all;
numberOfBlocks = 1;
nrOfTests = 1;
% blockSize = 188; MPEG2-sized blocks, for now using testsize
% originalSequence = zeros(1,(numberOfBlocks*blockSize*8));
rate = '1_2'; % 1_3, 2_5, 1_2, 2_3, 3_4, 4_5, 6_7
noisePower = 0; % Perfect transmission

if(noisePower~=0)
    noisePowerDb = 10*log10(noisePower);
else
    noisePowerDb = -100000;
end


%%%%%%%%%%%% PUNCTURES %%%%%%%%%%%%%
% All original bits are allways sent (naturally, since the code is
% systematic), but none of the interleaved bits need to be sent, since the
% permutation is known and hence can be done on the receiver side as well.
% The puncture patterns below apply to the two kinds of parity bits,
% defined by the two different generators in the encoder, i.e.
% [Y Y Y Y Y Y Y Y]
% [W W W W W W W W]


%%% Rate: 1/3

puncture1 = [1 1 1 1 1 1 1 1;
             1 1 1 1 1 1 1 1];

%%% Rate: 2/5

puncture2 = [1 1 1 1 1 1 1 1;
             1 0 1 0 1 0 1 0];
          
%%% Rate: 1/2

puncture3 = [1 1 1 1 1 1 1 1;
             0 0 0 0 0 0 0 0];

%%% Rate: 2/3

puncture4 = [1 0 1 0 1 0 1 0;
             0 0 0 0 0 0 0 0];
% 
% %%% Rate: 3/4 NOTE: blir litt anderledes, kan ikke bare konkatenere
% %%% patternet under. skal sikkert g? slik: 1 0 0 1 0 0 1 0 0 1 0 0
% 
% puncture5 = [1 0 0 1 0 0 1 0;
%              0 0 0 0 0 0 0 0];

%%% Rate: 4/5

puncture6 = [1 0 0 0 1 0 0 0;
             0 0 0 0 0 0 0 0];
% 
% %%% Rate: 6/7 Ogs? denne m? sannsynligvis moddes litt
% 
% puncture7 = [1 0 0 0 0 0 1 0;
%             0 0 0 0 0 0 0 0];
% 

%%%%%%%%%%% TEST-VALUES %%%%%%%%%%%%

blockSize = 16; % Testblock
testSeq = [1 0 0 0 0 1 1 1];
originalSequence = [];
for i=1:blockSize
    originalSequence = [originalSequence testSeq];
end

for iteration=1:nrOfTests

    %%%%%%%%%%%%%% NOISE %%%%%%%%%%%%%%%



    %% ENCODING
    % Konvolusjonskoder inngangsdataene, og mapper de til signalkonstellasjonen

    % Determine the circular state
    [discard, endStates] = turboEncode(originalSequence,[0 0 0;0 0 0], false);
    circStates = findCircularStates(endStates,length(originalSequence));

    % Perform circular encoding
    [channelPreinput, lastStates] = turboEncode(originalSequence, circStates, true);

    channelInput = bpskMap(channelPreinput);

    %% CHANNEL
    % Adds gaussian white noise, with the defined power to each of the symbols

    if(noisePower~=0)
        noise = sqrt(noisePowerDb).*randn(3,length(originalSequence));
    else
        noise = zeros(3,length(originalSequence));
    end

    channelOutput = channelInput + noise;

    %% DECODING
    % Iterativ, parallell "turbo" decoding of the input data blocks, where each
    % individual SISO-decoder outputs extrinsic information, in addition to
    % soft decisions regarding the input data.


    decodedSequence = decodeSequence(channelOutput);

    %% Saving results
    saveString = strcat('Savefiles/results_','rate',rate,'_snrdB',snrdB, ... 
        '_iteration',iteration,'.mat');
    save saveString originalSequence decodedSequence snrdB numberOfBlocks ... 
        blockSize rate noisePowerDb;
end

%%% Testing
% 
% 'States circular?'
% circStates
% lastStates
% 
% 'Parity sequences'
% channelPreinput(2,:)
% channelPreinput(3,:)
% 
% decodedSequence(2,:)
% decodedSequence(3,:)