%  function [al,bet] = decodeSequence(input)
%%%%%%%%%%%%%%%%%%%%%%%% temp allocation of input for testing %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%% Abandoned after decision about implementing all of the turbocode in C %%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

    
blockSize = 16; % Testblock
testSeq = [1 0 0 0 0 1 1 1];
originalSequence = [];
for i=1:blockSize
originalSequence = [originalSequence testSeq];
end
noisePower = 0; % Perfect transmission
%%%%%%%%%%%%%% NOISE %%%%%%%%%%%%%%%
if(noisePower~=0)
noisePowerDb = 10*log10(noisePower);
else
noisePowerDb = -100000;
end
%% ENCODING
% Konvolusjonskoder inngangsdataene, og mapper de til signalkonstellasjonen
% Determine the circular state
[discard, endStates] = turboEncode(originalSequence,[0 0 0;0 0 0], false);
circStates = findCircularStates(endStates,length(originalSequence));
% Perform circular encoding
[channelPreinput, lastStates] = turboEncode(originalSequence, circStates, true);
input = bpskMap(channelPreinput);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    

    %% Helper-values for computation of the alphas, based on
    %% the trellis and possible transitions. The rows are organized as
    %% follows: #1: the preceeding alphavalue #2: A #3: B #4: Y #5: W,
    %% where #2-5 are determined by the trellis/ state diagram, 
    
    alphaTrans = [  %% Transitions to the 000, AKA 0-state:
                    1, -1, -1, -1, -1;
                    7, -1, 1, 1, -1;
                    2, 1, -1, 1, 1;
                    8, 1, 1, -1, 1;
                    
                    %% Transitions to the 001, AKA 1-state:
                    3, -1, -1, 1, -1;
                    5, -1, 1, -1, -1;
                    4, 1, -1, -1, 1;
                    6, 1, 1, 1, 1;
                  
                    %% Transitions to the 010, AKA 2-state:
                    6, -1, -1, 1, 1;
                    4, -1, 1, -1, 1;
                    5, 1, -1, -1, -1;
                    3, 1, 1, 1, -1;
                    
                    %% Transitions to the 011, AKA 3-state:
                    8, -1, -1, -1, 1;
                    2, -1, 1, 1, 1;
                    7, 1, -1, 1, -1;
                    1, 1, 1, -1, -1;
                    
                    %% Transitions to the 100, AKA 4-state:
                    2, -1, -1, -1, -1;
                    8, -1, 1, 1, -1;
                    1, 1, -1, 1, 1;
                    7, 1, 1, -1, 1;
                    
                    %% Transitions to the 101, AKA 5-state:
                    4, -1, -1, 1, -1;
                    6, -1, 1, -1, -1;
                    3, 1, -1, -1, 1;
                    5, 1, 1, 1, 1;
                    
                    %% Transitions to the 110, AKA 6-state:
                    5, -1, -1, 1, 1;
                    3, -1, 1, -1, 1;
                    6, 1, -1, -1, -1;
                    4, 1, 1, 1, -1;
                    
                    %% Transitions to the 111, AKA 7-state:
                    7, -1, -1, -1, 1;
                    1, -1, 1, 1, 1;
                    8, 1, -1, 1, -1;
                    2, 1, 1, -1, -1;
                    ];
                
    %% Helper-values for computation of the betas, based on
    %% the trellis and possible transitions. The rows are organized as
    %% follows: #1: the preceeding betavalue #2: A #3: B #4: Y #5: W,
    %% where #2-5 are determined by the trellis/ state diagram
    
    %% Also used to keep track of which transition bits to multiply with 
    %% during calculation of extrinsic info, as well as which alpha and
    %% beta values to combine for each transition
    
    betaTrans = [   %% Transitions to the 000, AKA 0-state:
                    1, -1, -1, -1, -1;
                    8, -1, 1, 1, 1;
                    5, 1, -1, 1, 1;
                    4, 1, 1, -1, -1;
                    %% Transitions to the 001, AKA 1-state:
                    5, -1, -1, -1, -1;
                    4, -1, 1, 1, 1;
                    1, 1, -1, 1, 1;
                    8, 1, 1, -1, -1;
                    %% Transitions to the 010, AKA 2-state:
                    2, -1, -1, 1, -1;
                    7, -1, 1, -1, 1;
                    6, 1, -1, -1, 1;
                    3, 1, 1, 1, -1;
                    %% Transitions to the 011, AKA 3-state:
                    6, -1, -1, 1, -1;
                    3, -1, 1, -1, 1;
                    2, 1, -1, -1, 1;
                    7, 1, 1, 1, -1;
                    %% Transitions to the 100, AKA 4-state:
                    7, -1, -1, 1, 1;
                    2, -1, 1, -1, -1;
                    3, 1, -1, -1, -1;
                    6, 1, 1, 1, 1;
                    %% Transitions to the 101, AKA 5-state:
                    3, -1, -1, 1, 1;
                    6, -1, 1, -1, -1;
                    7, 1, -1, -1, -1;
                    2, 1, 1, 1, 1;
                    %% Transitions to the 110, AKA 6-state:
                    8, -1, -1, -1, 1;
                    1, -1, 1, 1, -1;
                    4, 1, -1, 1, -1;
                    5, 1, 1, -1, 1;
                    %% Transitions to the 111, AKA 7-state:
                    4, -1, -1, -1, 1;
                    5, -1, 1, 1, -1;
                    8, 1, -1, 1, -1;
                    1, 1, 1, -1, 1;
                    ];
                
    %% Initialization of helper values
    numberOfSymbols = length(input)/2;
    maxIterations = 1;
    
    %% Alpha and beta values
    alphas = zeros(8,numberOfSymbols+1);
    betas = zeros(8,numberOfSymbols+1);
    intAlphas = zeros(8,numberOfSymbols+1);
    intBetas = zeros(8,numberOfSymbols+1);
    
    %% Extrinsic information ln(P(d_k)) in the natural order d_k = 00,
    %% 01, 10 and 11
    extrinsicOne = zeros(4,numberOfSymbols);
    extrinsicOneInt = zeros(4,numberOfSymbols);
    extrinsicTwo = zeros(4,numberOfSymbols);
    extrinsicTwoInt = zeros(4,numberOfSymbols);
    
    %% Interleaved indices for input and probabilities
    intInputIndex = interleave(numberOfSymbols*2);
    intProbIndex = interleaveProb(numberOfSymbols);
    
    %% The final log-likelihoods, produced after the appointed
    %% number of iterations has been executed, by the second
    %% componentdecoder. (Note: These are not normalized by the likelihood 
    %% of d_k = 00
    loglikelihoods = zeros(4,numberOfSymbols);
        
    for i=1:maxIterations
        
        %%%%%%%%%%%% First decoder %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        %% computing alphas
        alphas = zeros(8,numberOfSymbols+1);
        temp = zeros(1,4);
        len = numberOfSymbols*2;
        for ii=1:2:len
            
            %% Computing the 8 next alpha values
            pairAddress = (ii+1)/2;
            for aInd=1:4:29
                temp(1) = alphas(alphaTrans(aInd, 1),pairAddress) + alphaTrans(aInd, 2)*input(1,ii) ...
                + alphaTrans(aInd, 3)*input(1,(ii+1)) + alphaTrans(aInd, 4)*input(2,ii) ...
                + alphaTrans(aInd, 5)*input(3,ii) + extrinsicTwoInt(1,pairAddress);
                
                temp(2) = alphas(alphaTrans((aInd+1), 1),pairAddress) + alphaTrans((aInd+1), 2)*input(1,ii) ...
                + alphaTrans((aInd+1), 3)*input(1,(ii+1)) + alphaTrans((aInd+1), 4)*input(2,ii) ...
                + alphaTrans((aInd+1), 5)*input(3,ii) + extrinsicTwoInt(2,pairAddress);
                
                temp(3) = alphas(alphaTrans((aInd+2), 1),pairAddress) + alphaTrans((aInd+2), 2)*input(1,ii) ...
                + alphaTrans((aInd+2), 3)*input(1,(ii+1)) + alphaTrans((aInd+2), 4)*input(2,ii) ...
                + alphaTrans((aInd+2), 5)*input(3,ii) + extrinsicTwoInt(3,pairAddress);
                
                temp(4) = alphas(alphaTrans((aInd+3), 1),pairAddress) + alphaTrans((aInd+3), 2)*input(1,ii) ...
                + alphaTrans((aInd+3), 3)*input(1,(ii+1)) + alphaTrans((aInd+3), 4)*input(2,ii) ...
                + alphaTrans((aInd+3), 5)*input(3,ii) + extrinsicTwoInt(4,pairAddress);
                
                alphas(((aInd-1)/4+1),(pairAddress+1)) = max(temp);
            end
        end
        alphas(:,1) = alphas(:,end);

        %% computing betas
        betas = zeros(8,numberOfSymbols+1);
        temp = zeros(1,4);
        bLen = len-1;
        for ii=bLen:-2:1
            
            %% Computing the 8 next alpha values
            pairAddress = (ii+1)/2;
            for bInd=1:4:29
                temp(1) = betas(betaTrans(bInd, 1),(pairAddress+1)) + betaTrans(bInd, 2)*input(1,ii) ...
                + betaTrans(bInd, 3)*input(1,(ii+1)) + betaTrans(bInd, 4)*input(2,ii) ...
                + betaTrans(bInd, 5)*input(3,ii) + extrinsicTwoInt(1,pairAddress);
                
                temp(2) = betas(betaTrans((bInd+1), 1),(pairAddress+1)) + betaTrans((bInd+1), 2)*input(1,ii) ...
                + betaTrans((bInd+1), 3)*input(1,(ii+1)) + betaTrans((bInd+1), 4)*input(2,ii) ...
                + betaTrans((bInd+1), 5)*input(3,ii) + extrinsicTwoInt(2,pairAddress);
                
                temp(3) = betas(betaTrans((bInd+2), 1),(pairAddress+1)) + betaTrans((bInd+2), 2)*input(1,ii) ...
                + betaTrans((bInd+2), 3)*input(1,(ii+1)) + betaTrans((bInd+2), 4)*input(2,ii) ...
                + betaTrans((bInd+2), 5)*input(3,ii) + extrinsicTwoInt(3,pairAddress);
                
                temp(4) = betas(betaTrans((bInd+3), 1),(pairAddress+1)) + betaTrans((bInd+3), 2)*input(1,ii) ...
                + betaTrans((bInd+3), 3)*input(1,(ii+1)) + betaTrans((bInd+3), 4)*input(2,ii) ...
                + betaTrans((bInd+3), 5)*input(3,ii) + extrinsicTwoInt(4,pairAddress);
                
                betas(((bInd-1)/4+1),pairAddress) = max(temp);
            end
        end
        betas(:,end) = betas(:,1);
        
        
        %% computing extrinsic information
        
        t2 = zeros(8,4);
        
        for n=1:numberOfSymbols
            
            %inputs = [input(1,((n*2)-1):(n*2))';input(2:3,((n*2)-1))];
            
            for nn=1:4
                bTemp = betaTrans(nn:4:end,:);
                t2(:,nn) = bTemp(:,4:5)*input(2:3,((n*2)-1)) + alphas(:,n) + betas(bTemp(:,1),(n+1));
                extrinsicOne(nn,n) = max(t2(:,nn));
            end
        end
        
        %% Subtracting the previous extrinsic info from the output
        extrinsicOne = extrinsicOne - extrinsicTwoInt; 
        
        %% Interleaving the extrinsic probabilities, with the indices
        %% generated by the helper function interleaveProb()
        for ii=1:numberOfSymbols
            extrinsicOneInt(:,ii) = extrinsicOne(intProbIndex(2:5,ii),intProbIndex(1,ii));
        end
        
        %%%%%%%%%% Second decoder %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

        %% computing alphas for interleaved input
        intAlphas = zeros(8,numberOfSymbols+1);
        temp = zeros(1,4);
        len = numberOfSymbols*2;
        for ii=1:2:len
            
            %% Computing the 8 next alpha values
            redundanceIndex = ceil(intInputIndex(ii)/2)*2;
            pairAddress = (ii+1)/2;
            
            for aInd=1:4:29
                temp(1) = intAlphas(alphaTrans(aInd, 1),pairAddress) + alphaTrans(aInd, 2)*input(1,intInputIndex(ii)) ...
                + alphaTrans(aInd, 3)*input(1,intInputIndex(ii+1)) + alphaTrans(aInd, 4)*input(2,redundanceIndex) ...
                + alphaTrans(aInd, 5)*input(3,redundanceIndex) + extrinsicOneInt(1,pairAddress);
                
                temp(2) = intAlphas(alphaTrans((aInd+1), 1),pairAddress) + alphaTrans((aInd+1), 2)*input(1,intInputIndex(ii)) ...
                + alphaTrans((aInd+1), 3)*input(1,intInputIndex(ii+1)) + alphaTrans((aInd+1), 4)*input(2,redundanceIndex) ...
                + alphaTrans((aInd+1), 5)*input(3,redundanceIndex) + extrinsicOneInt(2,pairAddress);
                
                temp(3) = intAlphas(alphaTrans((aInd+2), 1),pairAddress) + alphaTrans((aInd+2), 2)*input(1,intInputIndex(ii)) ...
                + alphaTrans((aInd+2), 3)*input(1,intInputIndex(ii+1)) + alphaTrans((aInd+2), 4)*input(2,redundanceIndex) ...
                + alphaTrans((aInd+2), 5)*input(3,redundanceIndex) + extrinsicOneInt(3,pairAddress);
                
                temp(4) = intAlphas(alphaTrans((aInd+3), 1),pairAddress) + alphaTrans((aInd+3), 2)*input(1,intInputIndex(ii)) ...
                + alphaTrans((aInd+3), 3)*input(1,intInputIndex(ii+1)) + alphaTrans((aInd+3), 4)*input(2,redundanceIndex) ...
                + alphaTrans((aInd+3), 5)*input(3,redundanceIndex) + extrinsicOneInt(4,pairAddress);
                
                intAlphas(((aInd-1)/4+1),(pairAddress+1)) = max(temp);
            end
        end
        intAlphas(:,1) = intAlphas(:,end);

        %% computing betas
        intBetas = zeros(8,numberOfSymbols+1);
        temp = zeros(1,4);
        bLen = len-1;
        for ii=bLen:-2:1
            
            %% Computing the 8 next alpha values
            redundanceIndex = ceil(intInputIndex(ii)/2)*2;
            pairAddress = (ii+1)/2;
            
            for bInd=1:4:29
                temp(1) = intBetas(betaTrans(bInd, 1),(ii+3)/2) + betaTrans(bInd, 2)*input(1,intInputIndex(ii)) ...
                + betaTrans(bInd, 3)*input(1,intInputIndex(ii+1)) + betaTrans(bInd, 4)*input(2,redundanceIndex) ...
                + betaTrans(bInd, 5)*input(3,redundanceIndex) + extrinsicOneInt(1,pairAddress);
                
                temp(2) = intBetas(betaTrans((bInd+1), 1),(ii+3)/2) + betaTrans((bInd+1), 2)*input(1,intInputIndex(ii)) ...
                + betaTrans((bInd+1), 3)*input(1,intInputIndex(ii+1)) + betaTrans((bInd+1), 4)*input(2,redundanceIndex) ...
                + betaTrans((bInd+1), 5)*input(3,redundanceIndex) + extrinsicOneInt(2,pairAddress);
                
                temp(3) = intBetas(betaTrans((bInd+2), 1),(ii+3)/2) + betaTrans((bInd+2), 2)*input(1,intInputIndex(ii)) ...
                + betaTrans((bInd+2), 3)*input(1,intInputIndex(ii+1)) + betaTrans((bInd+2), 4)*input(2,redundanceIndex) ...
                + betaTrans((bInd+2), 5)*input(3,redundanceIndex) + extrinsicOneInt(3,pairAddress);
                
                temp(4) = intBetas(betaTrans((bInd+3), 1),(ii+3)/2) + betaTrans((bInd+3), 2)*input(1,intInputIndex(ii)) ...
                + betaTrans((bInd+3), 3)*input(1,intInputIndex(ii+1)) + betaTrans((bInd+3), 4)*input(2,redundanceIndex) ...
                + betaTrans((bInd+3), 5)*input(3,redundanceIndex) + extrinsicOneInt(4,pairAddress);
                
                intBetas(((bInd-1)/4+1),(ii+1)/2) = max(temp);
            end
        end
        intBetas(:,end) = intBetas(:,1);
        
        %% computing extrinsic information
        
        t2 = zeros(8,4);
        for n=1:numberOfSymbols
            
            %inputs = [input(1,intInputIndex(((n*2)-1):(n*2)))';input(2:3,intInputIndex(n*2))];
            redundanceIndex = ceil(intInputIndex(n*2)/2)*2;
            
            for nn=1:4
                bTemp = betaTrans(nn:4:end,:);
                t2(:,nn) = bTemp(:,4:5)*input(2:3,redundanceIndex) + intAlphas(:,n) + intBetas(bTemp(:,1),(n+1));
                extrinsicTwo(nn,n) = max(t2(:,nn));
            end
        end
        
        %% Subtracting the previous extrinsic info from the output
        extrinsicTwo = extrinsicTwo - extrinsicOneInt;
        
        %% Interleaving the extrinsic probabilities
        
        for ii=1:numberOfSymbols
            extrinsicTwoInt(intProbIndex(2:5,ii),intProbIndex(1,ii)) = extrinsicTwo(:,ii);
        end
        
    end % end of the loop iterating between the two component decoders 
    
    %% Computing the final APP, including the factors from
    %% input*transitional bits
    
    t2 = zeros(8,4);
    intLoglikelihoods = zeros(4,numberOfSymbols);
    for n=1:numberOfSymbols

        redundanceIndex = ceil(intInputIndex(n*2)/2)*2;
        inputs = [input(1,intInputIndex(((n*2)-1):(n*2)))';input(2:3,redundanceIndex)];

        for nn=1:4
            bTemp = betaTrans(nn:4:end,:);
            t2(:,nn) = bTemp(:,2:5)*inputs + intAlphas(:,n) + intBetas(bTemp(:,1),(n+1));
            intLoglikelihoods(nn,n) = max(t2(:,nn));
        end
    end
    
    %% De-interleaving the loglikelihoods for the interlaeved input
    for ii=1:numberOfSymbols
        loglikelihoods(intProbIndex(2:5,ii),intProbIndex(1,ii)) = intLoglikelihoods(:,ii);
    end
    
    [maxvalues,maxIndices] = max(loglikelihoods,[],1);

    outputPairs = [0 0; 0 1; 1 0; 1 1];
    out = [];
    
    for i=1:length(maxIndices)
        out = [out outputPairs(maxIndices(i),:)];
    end
    
    'done'
    
% end