%%% Computes circular states for both the natural and interleaved data in 
%%% the turbo encoder, by way of a look-up in the table given in the 
%%% DVB-RCS turbo code standard

function circStates = findCircularStates(endStates, lengthOfSequence)

    circTable = [0 6 4 2 7 1 3 5;
                 0 3 7 4 5 6 2 1;
                 0 5 3 6 2 7 1 4;
                 0 4 1 5 6 2 7 3;
                 0 2 5 7 1 3 4 6;
                 0 7 6 1 3 4 5 2];

    % Converting strings, binary and decimal numbers to compute the states
    circTemps = dec2bin(circTable(mod(lengthOfSequence/2,7),(1+endStates*[4;2;1])),3);
    circStates(1,:) = [strcmp(circTemps(1,1),'1'),strcmp(circTemps(1,2),'1'),strcmp(circTemps(1,3),'1')];
    circStates(2,:) = [strcmp(circTemps(2,1),'1'),strcmp(circTemps(2,2),'1'),strcmp(circTemps(2,3),'1')];
end