%%% The interleaver permutation. Corresponds with test values for turbo
%%% encoders, found in ETSI TR 10179. This function outputs the indices for
%%% the the interleaved sequence
%%%
%%%%%%%% Abandoned after decision about implementing all of the turbocode in C %%%%%%%%%%%%%

function output = interleave(inputLength)

    % P values for blocksize of 16:
    Pval = [7 34 32 2];
    
    % Number of data couples
    N = inputLength/2;
    
    output = zeros(1,inputLength);
    
    for j = 0:N-1

        % Second level of permutation: calculating new couple address
        switchCase = mod(j,4);
        
        switch switchCase
            case 0
                P = 0;
            case 1
                P = N/2 + Pval(2);
            case 2
                P = Pval(3);
            case 3
                P = N/2 + Pval(4);
        end
        
        i = mod((Pval(1)*j + P),N);
        
        % First level permutation: swapping couples
        if mod(j,2)==0
            output((2*i+1):(2*i+2)) = (2*j+2):-1:(2*j+1);
        else
            output((2*i+1):(2*i+2)) = (2*j+1):(2*j+2);
        end
    end
end

