%%% The interleaver permutation, modified for the extrinsic probabilities.
%%% Still outputs the indices for the interleaved input
%%% Abandoned after decision about implementing all of the turbocode in C

function output = interleaveProb(inputLengthInPairs)

    % P values for blocksize of 16:
    Pval = [7 34 32 2];
    
    % Number of data couples
    N = inputLengthInPairs;
    
    output = zeros(5,N);
    shifted = [1;3;2;4];
    normal = [1;2;3;4];
    
    for j = 0:N-1

        % Second level of permutation: calculating new couple address
        switchCase = mod(j,4);
        
        switch switchCase
            case 0
                P = 0;
            case 1
                P = N/2 + Pval(2);
            case 2
                P = Pval(3);
            case 3
                P = N/2 + Pval(4);
        end
        
        i = mod((Pval(1)*j + P),N);
        
        % First level permutation: swapping couples, because the 01- and
        % 10-probabilities exchange places if the couples are inverted
        
        if mod(j,2)==0
            output(2:5,(i+1)) = shifted;
        else
            output(2:5,(i+1)) = normal;
        end
        
        % Performing second level of permutation
        output(1,(i+1)) = (j+1);
    end
end

